/***************************************************************************

  BionxControl
  Copyright © 2025 christoph holzheuer
  christoph.holzheuer@gmail.com

  Using:

  mhs_can_drv.c
  © 2011 - 2023 by MHS-Elektronik GmbH & Co. KG, Germany
  Klaus Demlehner, klaus@mhs-elektronik.de
  @see www.mhs-elektronik.de

  Based on Bionx data type descriptions from:

  BigXionFlasher USB V 0.2.4 rev. 97
  © 2011-2013 by Thomas Koenig <info@bigxionflasher.org>
  @see www.bigxionflasher.org

  Bionx Bike Info
  © 2018 Thorsten Schmidt (tschmidt@ts-soft.de)
  @see www.ts-soft.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  @see https://github.com/bikemike/bionx-bikeinfo

 ***************************************************************************/


#include <bcdevicepanel.h>
#include <bcdelegate.h>

BCDevicePanel::BCDevicePanel(QWidget *parent)
  : QWidget(parent)
{
  setupUi(this);
  _valueView->setModel( &_valueModel );
  //_valueView->resizeColumnsToContents();
  //_valueView->horizontalHeader()->setSectionResizeMode(QHeaderView::ResizeToContents);

  BCDelegate* delegate = new BCDelegate( _valueModel.getValueList(), _valueView);
  _valueView->setItemDelegate( delegate );
}



void BCDevicePanel::setHeaderText( const QString& headerText)
{
  _headerLabel->setText( headerText );
}

QString BCDevicePanel::getHeaderText() const
{
  return _headerLabel->text();
}

void BCDevicePanel::setDeviceID( BCDevice::ID deviceID )
{
  _devideID = deviceID;
}

BCDevice::ID BCDevicePanel::getDeviceID() const
{
  return _devideID;
}


QTableView* BCDevicePanel::getValueView()
{
  return _valueView;
}

const BCValueList& BCDevicePanel::getValueListX()
{
  return _valueModel.getValueList();
}

BCValueModel& BCDevicePanel::getValueModel()
{
  return _valueModel;
}

// __FIX ist das ok so?
void BCDevicePanel::onValueListReady( BCDevice::ID deviceID, BCValueList valueList )
{
  qDebug() << " --- onValueListReady: " << getHeaderText() <<" : " << deviceID << ": " << valueList.size();
  if(_devideID == deviceID)
    _valueModel.takeValueList( valueList );
}



